/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_syssvc.h 698 2007-12-25 04:45:08Z honda $
 */

/*
 *  ץå¸⥸塼 ֥Nios2ѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */

/*
 *  ֥ѤΥޥͭˤ
 */
#define TOPPERS_ASM_MACRO
#include "kernel_impl.h"
#include "offset.h"

/*
 * å : ץå
 */
 .macro Push source
 addi  sp, sp, -4
 stw   \source, 0(sp)
 .endm	

/*
 * å : ݥå
 */
 .macro Pop source
 ldw   \source, 0(sp)
 addi  sp, sp, 4
 .endm

/*
 *  㳰/ߥȥ
 */
	.set noat
	.section .exceptions, "xa"
	.align 2
	.global exception_entry
exception_entry:
	/*
	 *  㳰װȽ
	 */
	rdctl   et, estatus
	andi    et, et, 1
	beq     et, zero, _check_trap
	rdctl   et, ipending
	beq     et, zero, _check_trap

/*
 *  㳰װߤξ
 */
interrupt:
	addi ea, ea, -4      /* Ϥǥ */
	/*
	 *  ƥȤ¸
	 */
	addi  sp, sp, -76    
	rdctl et, estatus
	stw   et,   0(sp)
	stw   at,   4(sp)
	stw   r2,   8(sp)
	stw   r3,  12(sp)
	stw   r4,  16(sp)
	stw   r5,  20(sp)
	stw   r6,  24(sp)
	stw   r7,  28(sp)
	stw   r8,  32(sp)
	stw   r9,  36(sp)
	stw   r10, 40(sp)
	stw   r11, 44(sp)
	stw   r12, 48(sp)
	stw   r13, 52(sp)
	stw   r14, 56(sp)
	stw   r15, 60(sp)
	stw   fp,  64(sp)
	stw   ra,  68(sp)
	stw   ea,  72(sp)

	/*
	 *  ¿ųߤȽ
	 */
	ldw   r3, %gprel(except_nest_count)(gp)  /* ͥȲΥå */
	bltu  zero, r3,  nest_int

	/*
	 * åݥ󥿤ؤ
	 */
	ldw   r2, %gprel(_kernel_istkpt)(gp)
	addi  r2, r2, -4
	stw   sp, 0(r2)     /* åݥ󥿤¸ */        
	mov   sp, r2        /* åݥ󥿤ؤ */

nest_int:
	/* 
	 *  ߡ㳰ΥͥȲΥ󥯥
	 */
	addi  r3, r3, 1
	stw   r3, %gprel(except_nest_count)(gp)

	/*
	 *  װμ 
	 */
#ifdef NIOS2_USE_INT_VEC_INST
	/*
	 *  Interrupt Vector Instruction ̿ľ
	 */
	custom NIOS2_INT_VEC_INST_NO, r4, r0, r0  /* ֹɤ߹(8ܤΤɤ߹) */
	srli   r4, r4, 3      /* 8ʬ1ˤ */
#else
	/*
	 *  ipending 1ΥӥåȤ⡤ǤⲼ̡ʱˤΤΤ򥵡
	 */
int_bitmap_search:
	rdctl r4, ipending
	andi  r2, r4, 65535
	mov   r5, zero
	bne   r2, zero, int_bitmap_search1
	srli  r4, r4, 16
	movi  r5, 16
int_bitmap_search1:
	andi  r2, r4, 255
	bne   r2, zero, int_bitmap_search2
	srli  r4, r4, 8
	addi  r5, r5, 8
int_bitmap_search2:
	andi  r2, r4, 15
	srli  r4, r4, 4
	bne   r2, zero, int_bitmap_search3
	addi  r5, r5, 4
	andi  r2, r4, 15
int_bitmap_search3:
	movhi r3, %hiadj(int_bitmap_search_table-1)
	addi  r3, r3, %lo(int_bitmap_search_table-1)
	add   r3, r2, r3
	ldbu  r2, 0(r3)
	add   r4, r2, r5
#endif

	/*
	 *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
	 *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
	 *  ¸롥
	 */
	movhi r2, %hiadj(inh_iipm_tbl)  /* դߤγͥ٥ޥ */
	addi  r2, r2, %lo(inh_iipm_tbl) /*  */
	add   r3, r4, r2
	ldbu  r5, 0(r3)
	ldbu  r2, %gprel(iipm)(gp)      /* ȯγͥ٥ޥ */ 
	Push  r2                        /* å¸                     */
	stb   r5, %gprel(iipm)(gp)      /* (ǥ)ͥ٥ޥ򥻥å */

	/*
	 *  ienableդߤγͥ٤бޥӥåȤ
	 *  ͤ˥åȤ롥
	 */
	slli  r3, r5, 2                 /* ͥ٥ޥ4ܤƥեåȤ    */
	movhi r2, %hiadj(iipm_mask_tbl) /* ͥ٥ޥб߶ػߥѥ */ 
	addi  r2, r2, %lo(iipm_mask_tbl)
	add   r2, r2, r3
	ldw   r5, 0(r2)
	ldw   r8, %gprel(idf)(gp)       /* Ƴߤγ׵ػߥե饰ξ֤     */
	nor   r8, r8, r5                /* ξԤOR                           */
	wrctl ienable, r8               /* ꤷߤΤߵ                       */

	/*
	 *  ߥϥɥΥɥ쥹ɤ߹
	 */
	slli  r3, r4, 2                 /* ֹ4ܤƥեåȤ  */
	movhi r2, %hiadj(inh_tbl) 
	addi  r2, r2, %lo(inh_tbl)
	add   r2, r2, r3
	ldw   r5, 0(r2)

	/*
	 *  ߵ
	 */
	rdctl r3, status
	ori   r3, r3, STATUS_PIE
	wrctl status, r3

#ifdef LOG_INH_ENTER
	Push  r4           /* ֹ¸ */
	Push  r5           /* ϥɥ饢ɥ쥹¸ */
	call log_inh_enter 
	Pop   r5           /* ϥɥ饢ɥ쥹 */
	ldw   r4, 0(sp)    /*  ֹ */
#endif /* LOG_INH_ENTER */

	/* 
	 *  ߥϥɥƤӽФ 
	 */
	callr r5

#ifdef LOG_INH_LEAVE
	Pop  r4           /* ֹ */     
	call log_inh_leave
#endif /* LOG_INH_LEAVE */

	/*
	 *  ߶ػ
	 */
	rdctl r3, status
	movi  r4, ~STATUS_PIE
	and   r3, r3, r4
	wrctl status, r3
test1:

/*
 *  ߥϥɥ/CPU㳰ϥɥи
 *
 *  ret_intϡߥϥɥ餫äľ˼¹Ԥ롼ǡ
 *  ߥϥɥ齪λ塤åȰ¸ν¹Ԥ塤
 *  ͥγߤػߡåΥåˤ
 *  ֤ǸƤӽФ롥
 */
	.global ret_int
	.global ret_exc
rer_int:
ret_exc:
	/*
	 *  (ǥ)ͥ٥ޥ򸵤᤹
	 */
	Pop   r3                   /* (ǥ)ͥ٥ޥ */
	stb   r3, %gprel(iipm)(gp) /* (ǥ)ͥ٥ޥ򥻥å */
	slli  r3, r3, 2                 /* ͥ٥ޥ4ܤƥեåȤ    */
	movhi r2, %hiadj(iipm_mask_tbl) /* ͥ٥ޥб߶ػߥѥ */ 
	addi  r2, r2, %lo(iipm_mask_tbl)
	add   r2, r2, r3
	ldw   r5, 0(r2)
	ldw   r8, %gprel(idf)(gp)       /* Ƴߤγ׵ػߥե饰ξ֤     */
	nor   r8, r8, r5                /* ξԤOR                           */
	wrctl ienable, r8               /* ꤷߤΤߵ                       */

	/* 
	 *  ߡ㳰ΥͥȲΥǥ
	 */
	ldw   r3, %gprel(except_nest_count)(gp)
	addi  r3, r3, -1
	stw   r3, %gprel(except_nest_count)(gp)

	bltu  zero, r3, ret_int_1    /* ͥȲ1ʾʤ */

	ldw   r2, 0(sp)              /* åݥ󥿤᤹    */
	mov   sp, r2
	ldw   r3, %gprel(reqflg)(gp) /* reqflgΥå          */
	beq   r3, zero, ret_int_1    /* false ʤ    */    
	br    ret_int_2              /* true ʤ ret_int_2     */

ret_int_1:
	ldw   et,   0(sp)  /* 쥸 */
	wrctl estatus, et
	ldw   at,   4(sp)
	ldw   r2,   8(sp)
	ldw   r3,  12(sp)
	ldw   r4,  16(sp)
	ldw   r5,  20(sp)
	ldw   r6,  24(sp)
	ldw   r7,  28(sp)
	ldw   r8,  32(sp)
	ldw   r9,  36(sp)
	ldw   r10, 40(sp)
	ldw   r11, 44(sp)
	ldw   r12, 48(sp)
	ldw   r13, 52(sp)
	ldw   r14, 56(sp)
	ldw   r15, 60(sp)
	ldw   fp,  64(sp)
	ldw   ra,  68(sp)
	ldw   ea,  72(sp)
	addi  sp, sp, 76        
	eret    

	/*
	 * 㳰ȥåפȽ
	 */
_check_trap:
	/*
	 *  TrapȽ
	 */
	ldw   et, -4(ea)               /* 㳰Ф̿ */
	xorhi et, et, 0x003b           /*  16bit             */
	xori  et, et, 0x683a           /*  16bit             */
	beq   et, zero, trap_handler

	/*
	 *  㳰ȥ
	 */
exception:
	/*
	 * ƥȤ¸
	 */
	addi  sp, sp, -76
	rdctl et,   estatus
	stw   et,    0(sp)
	stw   at,    4(sp)
	stw   r2,    8(sp)
	stw   r3,   12(sp)
	stw   r4,   16(sp)
	stw   r5,   20(sp)
	stw   r6,   24(sp)
	stw   r7,   28(sp)
	stw   r8,   32(sp)
	stw   r9,   36(sp)
	stw   r10,  40(sp)
	stw   r11,  44(sp)
	stw   r12,  48(sp)
	stw   r13,  52(sp)
	stw   r14,  56(sp)
	stw   r15,  60(sp)
	stw   fp,   64(sp)
	stw   ra,   68(sp)
	stw   ea,   72(sp)
	mov   r4,   sp     /* ϥɥΰ */

	/*
	 * ¿ųߤȽ
	 */
	ldw   r3, %gprel(except_nest_count)(gp)  /* ͥȲΥå */
	bltu  zero, r3,  nest_int_exc

	/*
	 * åݥ󥿤ؤ
	 */
	ldw   r2, %gprel(_kernel_istkpt)(gp)
	addi  r2, r2, -4
	stw   sp, 0(r2)     /* åݥ󥿤¸ */        
	mov   sp, r2        /* åݥ󥿤ؤ */

nest_int_exc:
	/* 
	 *  ߡ㳰ΥͥȲΥ󥯥
	 */
	addi  r4, r3, 1
	stw   r4, %gprel(except_nest_count)(gp)

	/*
	 *  CPU㳰ֹμ(4ܤƤ)
	 */
#ifdef USE_EXTRA_EXCEPTION
	rdctl r5, exception
#else 
	mov   r5, zero
#endif /* USE_EXTRA_EXCEPTION */
	srli  r6, r5, 2

	/*
	 *  ȯγͥ٥ޥ򥹥å¸
	 */
	ldbu  r2, %gprel(iipm)(gp)
	Push  r2

	/*
	 *  㳰ե졼κ            եå
	 *    㳰ֹ                        0
	 *    ESTATUS(et)                     4
	 *    ߡ㳰ͥȥ(r3)  8
	 *    ꥢɥ쥹                   12  
	 *    ͥ٥ޥ(iipm)       16
	 */
	addi  sp,  sp, -20
	stw   r6,  0(sp)
	stw   et,  4(sp)
	stw   r3,  8(sp)
	stw   ea, 12(sp)
	stw   r2, 16(sp)

	/*
	 *  㳰ե졼ƬϤCPU㳰ϥɥΰr4
	 */
	mov   r4, sp

	/*
	 *  㳰ϥɥ饢ɥ쥹μ
	 */
	movhi r2, %hiadj(exch_tbl)  
	addi  r2, r2, %lo(exch_tbl) 
	add   r2, r2, r5
	ldw   r5, 0(r2)

	/*
	 *  㳰ȯCPUå֤ǤʤCPUå֤Ȥ
	 */
	rdctl r3, estatus
	andi  r3, r3, STATUS_PIE
	beq   r3, zero, call_exc_handler
	rdctl r3, status
	ori   r3, r3, STATUS_PIE
	wrctl status, r3

call_exc_handler:
#ifdef LOG_EXC_ENTER
	Push  r6         /* CPU㳰ֹ¸               */
	Push  r5         /* CPU㳰ϥɥ饢ɥ쥹¸   */
	Push  r4         /* CPU㳰ե졼Ƭ¸ */
	mov   r4, r6     /* CPU㳰ֹ           */
	call  log_exc_enter
	Pop   r4         /* CPU㳰ե졼Ƭ */
	Pop   r5         /* CPU㳰ϥɥ饢ɥ쥹   */
#endif /* LOG_EXC_ENTER */

	/* 
	 *  CPU㳰ϥɥƤӽФ 
	 */
	callr r5

#ifdef LOG_EXC_LEAVE
	Pop   r4         /* CPU㳰ֹ               */
	call  log_exc_leave
#endif /* LOG_EXC_LEAVE */

	/*
	 *  ߶ػ
	 */
	rdctl r3, status
	movi  r4, ~STATUS_PIE
	and   r3, r3, r4
	wrctl status, r3

	/*
	 *  㳰ե졼ΤƤ
	 */
	addi  sp,  sp, 20

	/*
	 *  㳰Υ꥿
	 */
	br    ret_exc

	/*
	 *  Trapϥɥ
	 */
trap_handler:
	eret  

	/*
	 *  ߥϥɥ/CPU㳰ϥɥи1
	 * 
	 *  Ǥϡ褬Ǥꡤåϡåξ
	 *  ˥å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
	 *  ץåϡѡХ⡼ɡͥγߤػ
	 *  ֤ȤʤäƤ롥
	 */  
ret_int_2:
	stw  zero, %gprel(reqflg)(gp)  /* reqflg  false  */

	/*
	 *  CPUå֤˰ܹԤ롥
	 *
	 *  λCPUå֤ȤΤϡdispatcherʬȡ
	 *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
	 *  Ǥ롥
	 *
	 *  Nios2ǤϡͥγߤߤʤᡤǤϡ
	 *  ä˲Ԥʤ
	 */

	/*
	 *  dspflgfalseǤȡp_runtskp_schedtskƱˤϡ
	 *  ǥѥåԤʤΥåɬפʤΤϡ㳰
	 *  롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
	 *  reqflgtrueˤ뤿Ǥ롥
	 */
	ldw   r5,   %gprel(p_runtsk)(gp)   /* r5 <- runtsk      */
	ldw   r6,   %gprel(dspflg)(gp)     /* r6 <- dspflg      */
	beq   r6,   zero, ret_int_3        /* dspflg  false ʤ ret_int_3  */
	ldw   r4,   %gprel(p_schedtsk)(gp) /* r4 <- p_schedtsk  */
	beq   r4,   r5, ret_int_3          /* runtsk  schedtskƱʤret_int_3 */
	addi  sp,   sp, -32                /* ĤΥ쥸¸ */    
	stw   r16,  0(sp)
	stw   r17,  4(sp)
	stw   r18,  8(sp)
	stw   r19, 12(sp)
	stw   r20, 16(sp)
	stw   r21, 20(sp)
	stw   r22, 24(sp)
	stw   r23, 28(sp)
	stw   sp,  TCB_sp(r5)         /* åTCB¸ */
	movhi r2,  %hiadj(ret_int_r)  /* ¹ԳϤ¸        */
	addi  r2,  r2, %lo(ret_int_r)
	stw   r2,  TCB_pc(r5)         /* ¹ԺƳϤTCB¸   */
	br    dispatcher

	/*
	 *  ߡ㳰ǥƥ¸롼
	 */
ret_int_r:
	ldw   r16,  0(sp)       /* 쥸 */
	ldw   r17,  4(sp)
	ldw   r18,  8(sp)
	ldw   r19, 12(sp)
	ldw   r20, 16(sp)
	ldw   r21, 20(sp)
	ldw   r22, 24(sp)
	ldw   r23, 28(sp)
	addi  sp, sp, 32    

ret_int_3:
	/*
	 * 㳰롼εư
	 * ret_int_r  dispatcher ƤӽФ뤿ᡤ
	 * tcb Υɥ쥹 r4 äƤ
	 */
	ldb  r5, TCB_enatex(r4)       /* r5 <- enatex */
#if TCB_enatex_mask > 0xffff
	andhi r6, r5, %hi(TCB_enatex_mask)
#else
	andi r6, r5, %lo(TCB_enatex_mask)
#endif /* TCB_enatex_mask > 0xffff */
	beq  r6, zero, ret_int_4      /* enatex  false ʤ꥿ */
	ldw  r7, TCB_texptn(r4)       /* r7 <- texptn, texptn0Ǥʤ */
	beq  zero, r7, ret_int_4      
	call call_texrtn              /* 㳰롼θƤӽФ */

ret_int_4:
	ldw   et,   0(sp)    /* 쥸 */
	wrctl estatus, et
	ldw   at,   4(sp)
	ldw   r2,   8(sp)
	ldw   r3,  12(sp)
	ldw   r4,  16(sp)
	ldw   r5,  20(sp)
	ldw   r6,  24(sp)
	ldw   r7,  28(sp)
	ldw   r8,  32(sp)
	ldw   r9,  36(sp)
	ldw   r10, 40(sp)
	ldw   r11, 44(sp)
	ldw   r12, 48(sp)
	ldw   r13, 52(sp)
	ldw   r14, 56(sp)
	ldw   r15, 60(sp)
	ldw   fp,  64(sp)
	ldw   ra,  68(sp)
	ldw   ea,  72(sp)
	addi  sp, sp, 76        
	eret 


/*
 * ǥѥå
 */
	.global dispatch
	.align  2
dispatch:
	/*
	 *  Υ롼ϡƥȡCPUå֡ǥѥå
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 *  롥
	 */
	addi  sp, sp, -40                /* 쥸¸ */    
	stw   r16,  0(sp)
	stw   r17,  4(sp)
	stw   r18,  8(sp)
	stw   r19, 12(sp)
	stw   r20, 16(sp)
	stw   r21, 20(sp)
	stw   r22, 24(sp)
	stw   r23, 28(sp)
	stw   fp,  32(sp)
	stw   ra,  36(sp)
	ldw   r4,  %gprel(p_runtsk)(gp) /* r4 <- runtsk              */
	stw   sp,  TCB_sp(r4)           /* åTCB¸ */
	movhi r5,  %hiadj(dispatch_r)   /* ¹ԳϤ¸        */
	addi  r5,  r5, %lo(dispatch_r)
	stw   r5,  TCB_pc(r4)           /* ¹ԺƳϤTCB¸   */
	br    dispatcher

dispatch_r:
	ldw   r16,  0(sp)               /* 쥸 */
	ldw   r17,  4(sp)
	ldw   r18,  8(sp)
	ldw   r19, 12(sp)
	ldw   r20, 16(sp)
	ldw   r21, 20(sp)
	ldw   r22, 24(sp)
	ldw   r23, 28(sp)
	ldw   fp,  32(sp)     

	/*
	 *  㳰롼εư
	 *  dispatch_r  dispatcher ƤӽФ뤿ᡤ
	 *  tcb Υɥ쥹 r4 äƤ
	 */
	ldb  r5, TCB_enatex(r4)       /* r5 <- enatex */
#if TCB_enatex_mask > 0xffff
	andhi r6, r5, %hi(TCB_enatex_mask)
#else
	andi r6, r5, %lo(TCB_enatex_mask)
#endif /* TCB_enatex_mask > 0xffff */
	beq  r6, zero, dispatch_r_1   /* enatex  false ʤ꥿ */
	ldw  r7, TCB_texptn(r4)       /* r7 <- texptn, texptn0Ǥʤ */
	beq  r7, zero, dispatch_r_1    
	call call_texrtn              /* 㳰롼θƤӽФ */

dispatch_r_1:
	ldw   ra, 36(sp)              /* ĤΥ쥸 */    
	addi  sp, sp, 40                
	ret

/*
 *  ǥѥåư
 */
    .globl start_dispatch
start_dispatch:
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
	 *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
	 *
	 *  dispatcherϡCPUå֡ʥǥΡ˳ͥ٥ޥ
	 *  ֡㳰ʳ/CPU㳰ˤΥͥȲ0ǸƤӽФ     
	 *  target_initializeǤϡʥǥΡ˳ͥ٥ޥ
	 *  ȤͥγߤǤFIQĤ뤳Ȥǡ
	 *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
	 *  ޤtask_initializedisdspfalse˽Ƥ뤿ᡤǥ
	 *  ѥåľ֤ˤʤäƤ롥
	 */ 
	/* 㳰ʳ/CPU㳰ˤΥͥȲ򥯥ꥢ */
	stw   zero, %gprel(except_nest_count)(gp)

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
    .globl exit_and_dispatch
exit_and_dispatch:
	/* ǥѥåΡdispatcherˤ */  

/*
 *  ǥѥå
 */
dispatcher:
	/*
	 *  Υ롼ϡƥȡCPUå֡ǥѥå
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 *  롥¹ԺƳϤؤ⤳ξ֤Τޤʬ롥
	 */
#ifdef LOG_DSP_ENTER
	ldw  r4,  %gprel(p_runtsk)(gp)
	call log_dsp_enter
#endif /* LOG_DSP_ENTER */

dispatcher_0:
	ldw  r4,   %gprel(p_schedtsk)(gp) /* r4 <- schedtsk              */
	stw  r4,   %gprel(p_runtsk)(gp)   /* schedtsk  runtsk        */
	beq  r4,   zero, dispatcher_1     /* schedtsk뤫            */
	ldw  sp,   TCB_sp(r4)             /* TCB饿å */

#ifdef LOG_DSP_LEAVE
	Push r4
	call log_dsp_leave
	Pop  r4
#endif /* LOG_DSP_LEAVE */

	ldw   r5,   TCB_pc(r4)           /* TCB¹ԺƳϤ   */
	jmp   r5

dispatcher_1:
	/*
	 * CPUå֤βȡ󥿥ƥȼ¹Ծ֤ؤ
	 * 򤹤
	 */
	ldw   r2, %gprel(_kernel_istkpt)(gp) /* 󥿥ƥѤΥåɤ߹ */
	mov   sp, r2                         /* åݥ󥿤ؤ */
	movi  r5, 1         
	stw   r5, %gprel(except_nest_count)(gp) /* except_nest_count 1    */ 
dispatcher_2:
	/*
	 *  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤġ
	 *
	 *  󥿥ƥȼ¹Ծ֤ڤ괹Τϡȯ
	 *  ߽ˤɤΥåȤȤβȡ
	 *  ϥɥǤΥǥѥåɻߤȤ2Ĥΰ̣롥
	 *
	 *  ץåԤ˰ܹԤȡߵĤȤϡԲ
	 *  ʬ˹Ԥʤɬפ롥
	 *  Բʬ˹Ԥʤʤ硤ߤĤľ˳
	 *  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
	 *  ˤ⤫餺ץåԤˤʤäƤޤ
	 *
	 *  Ԥδ֤ϡp_runtskNULLʡ0ˤꤷʤФʤ
	 *  Τ褦ꤷʤȡߥϥɥ餫iget_tidƤӽ
	 *  ݤưͤ˹פʤʤ롥
	 *
	 */
	rdctl r3, status          /* ߵ */
	ori   r3, r3, STATUS_PIE
	wrctl status, r3
	nop
	nop
	nop
	nop
	rdctl r3, status          /* ߶ػ */
	movi  r4, ~STATUS_PIE
	and   r3, r3, r4
	wrctl status, r3
	ldw   r6, %gprel(reqflg)(gp)              /* r6 <- reqflg             */
	beq   r6, zero, dispatcher_2              /* reqflg  FALSE ʤ     */
	stw   zero, %gprel(except_nest_count)(gp) /* interrupt_count 򥯥ꥢ */ 
	stw   zero, %gprel(reqflg)(gp)            /* reqflg  FALSE        */ 
	br    dispatcher_0

/*
 *  ͥνλθƽФ
 *
 *  ⡼ɤȥå󥿥ƥѤڤؤ
 */
    .globl call_exit_kernel
call_exit_kernel:
	ldw   r2, %gprel(_kernel_istkpt)(gp) /* 󥿥ƥѤΥåɤ߹ */
	mov   sp, r2                         /* åݥ󥿤ؤ */
	call  exit_kernel         

/*
 *  ϻ
 *
 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹 r4 äƤ
 */
	.text
	.global start_r
	.align 2
start_r:
	rdctl r3, status              /* ߵ */
	ori   r3, r3, STATUS_PIE
	wrctl status, r3
	ldw   r3, TCB_p_tinib(r4)     /* r3  <- p_runtsk->p_tinib     */
	ldw   r4, TINIB_exinf(r3)     /* r4  <- exinf         */
	ldw   r2, TINIB_task(r3)      /* r2 <- μ¹       */
	addi  sp, sp, 8
	movhi ra, %hiadj(ext_tsk)
	addi  ra, ra, %lo(ext_tsk)
	jmp   r2              /* μ¹Գ */


/*
 * Ԥ
 */
	.global sil_dly_nse
sil_dly_nse:
	addi   r4, r4, -SIL_DLY_TIM1
	bgt    r4, zero, sil_dly_nse_1
	ret
sil_dly_nse_1:
	addi   r4, r4, -SIL_DLY_TIM2
	bgt    r4, zero, sil_dly_nse_1
	ret
